// Demo the quad alphanumeric display LED backpack kit
// scrolls through every character, then scrolls Serial
// input onto the display

/* Connect CLK to the I2C clock -  Analog #5,
Connect DAT to the I2C data -  Analog #4, 
Connect GND to common ground
Connect VCC+ to power - 5V is best but 3V will work if that's all you've got (it will be dimmer)
Connect Vi2c to your microcontroller's logic level (3-5V) - If you're using an Arduino, this is almost certainly 5V. If its a 3V Arduino such as a Due, connect it to 3V

Both Vi2c and Vcc MUST be connected to 3 to 5VDC! Vcc is for the LED driver power, Vi2c is what sets the logic level for communication to the chip.
*/ 


int idleLoops = 0;

int buttonPin = 8; //button pin for Launch

 int buttonPushCounter = 0;   // counter for the number of button presses
int buttonState = 0;         // current state of the button
int lastButtonState =0;     // previous state of the button

// This variable gets toggled either high or low each time the button is pressed. 
// In other words, this variable changes states with each button press.
bool pressed = true;

int buttonpress;

//Sparkfun/Casco Bay Studios bargraph
// Step one: include both the SFEbarGraph and SPI libraries

#include <SparkFunBarGraph.h>
#include <SPI.h>

// Step two: create a bargraph object; we call it BG in this example but you can call it whatever you wish
// (use the same name in front of all the library functions)

SFEbarGraph BG;

// Some of the math we're doing in this example requires the number of bargraph boards
// you have connected together (normally this is one, but you can have a maximum of 8).

const int numbargraphs = 1;


#include <Wire.h>
#include <Adafruit_GFX.h>
#include "Adafruit_LEDBackpack.h"
const uint8_t addr = 0x70; // HT16K33 default address
//uint16_t displayBuffer[8];


Adafruit_AlphaNum4 alpha4 = Adafruit_AlphaNum4();


char *welcome = "    WELCOME TO MISSION CONTROL     ";

char *overload = "    ** OVERLOAD **    ";
char *liftoff = "    LIFT OFF     ";

char *commander = "    READY, COMMANDER BOWEN   ";
char *orders = "    AWAITING ORDERS   ";
char *houston = "    HOUSTON, WE ARE GO   ";
char *shuttle = "    SIC ITUR AD ASTRA    ";
char *nasa = "    NASA - FOR THE BENEFIT OF ALL    ";

char *funcPointer[] = {"engine", "booster", "units", "autoseq", "hydrogen", "arm"};


int BarGraf_POT = A0;
// controls bar graph breakout board. CLK 13, SIN 11, LAT 10


 
//power units animation array
   
int digit_0[20] = {0x0500, 0x0400, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x2000, 0x2800, 0x0810, 0x0030, 0x0120};
int digit_1[20] = {0x0000, 0x0100, 0x0500, 0x0400, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x2000, 0x2800, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000};
int digit_2[20] = {0x0000, 0x0000, 0x0000, 0x0100, 0x0500, 0x0400, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x2000, 0x2800, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000};
int digit_3[20] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0100, 0x0500, 0x0402, 0x0006, 0x2004, 0x2800, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000};


//booster animation array
int boost_0[5] = {0x003F, 0x2D3F, 0x3FFF, 0x12FF, 0x003F};
int boost_1[5] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0000};
int boost_2[5] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0000};
int boost_3[5] = {0x003F, 0x2D3F, 0x3FFF, 0x12FF, 0x003F};


//arm retraction animation

int arm_0[5] = {0x00C0, 0x00C0, 0x00C0, 0x2440, 0x0000};
int arm_1[5] = {0x00C0, 0x00C0, 0x2440, 0x0000, 0x0000};
int arm_2[5] = {0x00C0, 0x2440, 0x0000, 0x0000, 0x0000};
int arm_3[5] = {0x2440, 0x0000, 0x0000, 0x0000, 0x0000};

//hydrogen animation
int burn_0[6] = {0x2800, 0x0014, 0x2800, 0x0014, 0x2800, 0x0014};
int burn_1[6] = {0x2800, 0x0014, 0x2800, 0x0014, 0x2800, 0x0014};
int burn_2[6] = {0x2800, 0x0014, 0x2800, 0x0014, 0x2800, 0x0014};
int burn_3[6] = {0x2800, 0x0014, 0x2800, 0x0014, 0x2800, 0x0014};

// main engine animation array
int eng_0[5] = {0x00E3, 0x38E3, 0x00E3, 0x38E3, 0x00E3};
int eng_1[5] = {0x00E3, 0x38E3, 0x00E3, 0x38E3, 0x00E3};
int eng_2[5] = {0x00E3, 0x38E3, 0x00E3, 0x38E3, 0x00E3};
int eng_3[5] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0000};

// auto sequence start animation array
int auto_0[13] = {0x0010, 0x0020, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0008, 0x0010};
int auto_1[13] = {0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0008, 0x0000, 0x0000};
int auto_2[13] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0008, 0x0000, 0x0000, 0x0000};
int auto_3[13] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0000, 0x0000, 0x0000, 0x0000};




void setup() {

pinMode(2, OUTPUT); //Arm Retract
pinMode(3, OUTPUT); // H2 burn
pinMode(4, INPUT); // Auto Seq
pinMode(5, OUTPUT); // Aux poert
pinMode(6, OUTPUT); // main engine start
pinMode(7, OUTPUT); //booster
// pinMode(12, OUTPUT); //?

pinMode(BarGraf_POT, INPUT);

digitalWrite(2, HIGH);
digitalWrite(3, HIGH);
digitalWrite(4, HIGH);
digitalWrite(5, HIGH);
digitalWrite(6, HIGH);
digitalWrite(7, HIGH);


  // Let's initialize the bargraph library!
  // You can call BG.begin() several ways:

  // Without parameters, it defaults to one bargraph board and LATch pin set to 10 on Uno, or 53 on Mega.

  // You can also call it with the number of daisy-chained boards (1-8, default 1), using the default LATch pin.
  
  // Or you can call it with both the number of boards and the LATch pin you wish to use.
  // For two bargraphs and pin 9 for the latch pin, call BG.begin(2,9);
  
  BG.begin(numbargraphs);

//setup for the quad alphanumeric display

  alpha4.begin(0x70);  // pass in the address
  alpha4.writeDisplay();  // clear display
  Wire.begin();

 Serial.begin(9600);

  pinMode(buttonPin, INPUT); //Launch button input
  digitalWrite(buttonPin,HIGH); //need to have it go low when pressed.



randomSeed(2);       // Seed random number generator




// Cool animation tool https://gaspariscoding.github.io/Alphanumeric_Animation_Utility/





//welcome message

    for (uint8_t i=0; i<strlen(welcome)-4; i++) {
    alpha4.writeDigitAscii(0, welcome[i]);
    alpha4.writeDigitAscii(1, welcome[i+1]);
    alpha4.writeDigitAscii(2, welcome[i+2]);
    alpha4.writeDigitAscii(3, welcome[i+3]);
    alpha4.writeDisplay();
    delay(200);
alpha4.clear();
alpha4.writeDisplay();
  }


/*
//Segment table binary. 16 digits starting after "0b", a 0 means the segment is off, 1 turns it on

//  0b   0 0  0 0 0 0 0 0 0  0  0 0 0 0 0 0                 
//       0 DP N M L K J H G2 G1 F E D C B A
   
//   0b0000000000000001 // Seg A is on
//   0b0000000000000010 // Seg B is on  
// etc

---------------------------------------------------------------------
----------------------------------------------------------------------




+++                  ************     ************     ************               
+++                  ************     ************     ************              
+++                  **        **     **        **     **        **           
+++                  **        **     **        **     **        **          
+++                  **        **     **        **     ************                  
+++                  **        **     **        **     ************                  
+++                  **        **     **        **     **                  
+++++++++++++++      ************     ************     **              
+++++++++++++++      ************     ************     **                        


-----------------------------------------------------------------------
-----------------------------------------------------------------------

*/

int randNumber;
int randNum;
}
void loop() {

unsigned long endtime;

//Serial.println(analogRead(BarGraf_POT));
//Serial.println(digitalRead(4));
Serial.println(idleLoops);

alpha4.clear();
alpha4.writeDisplay();

BG.clear(); BG.send();



int randNumber = random(1,7); // for random function on Auto Seq button
int randNum = random(1,10); // for screen saver msgs 

      
        idleLoops++;
     
    if(idleLoops > 10000) //Play a screen saver every 60 seconds. or so.
    {
        screenSaver(randNum); //Screen saver = display title
        idleLoops = 0;
    }



int autoSeq = digitalRead(4);

if (autoSeq == LOW) {

 // Serial.println(funcPointer[index]); //use it as the index to the array of phrases
  callFunc(randNumber);
  idleLoops = 0;
}

 
// Serial.println(autoSeq);
 



// this works, when the NO pin i connected to the Arduino pin which is set to high 
int button = digitalRead(buttonPin);
if (button == LOW)  {
  countdown();
idleLoops = 0;
 
 }




//putting bargraph code here
  //pot code
 // read the potentiometer:
   int sensorReading = analogRead(BarGraf_POT);
   // map the result to a range from 0 to the number of LEDs:
  const int ledLevel = map(sensorReading, 0, 950, 0, (numbargraphs*30)); 
  
  // Trying to make "bugs" if power turned up too high.
  // BASIC BARGRAPH!
  
  // Turn all LEDs on then off using BG.barGraph()

  // BG.BarGraph() takes two values, one for the "bar" (how many LEDs to light), 
  // and a separate floating "peak" which lights up one LED.
  // When you call BG.barGraph(), the values are immediately displayed on the LEDs.
  // Numbering starts at 1, 0 = all LEDs off.

 
BG.barGraph(ledLevel,0); //simply plug in the variable from the pot et voila!
  
  //call up makebugs routine when the power level is 'overloaded'
   
 if (sensorReading>920) {
   bugs();
 }
 else  {
   regBG();
   }
   
 
  //end bargraph code

}




void countdown() {



alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, '1');
alpha4.writeDigitAscii(3, '0');
alpha4.writeDisplay();
 BG.barGraph(30,0);
delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();


alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '9');
alpha4.writeDisplay();
BG.barGraph(27,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();


alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '8');
alpha4.writeDisplay();
BG.barGraph(24,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '7');
alpha4.writeDisplay();
BG.barGraph(21,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '6');
alpha4.writeDisplay();
BG.barGraph(18,0);


delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '5');
alpha4.writeDisplay();
BG.barGraph(15,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '4');
alpha4.writeDisplay();
BG.barGraph(12,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '3');
alpha4.writeDisplay();
BG.barGraph(9,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '2');
alpha4.writeDisplay();

BG.barGraph(6,0);
delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '1');
alpha4.writeDisplay();
BG.barGraph(4,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitAscii(0, 'T');
alpha4.writeDigitAscii(1, '-');
alpha4.writeDigitAscii(2, ' ');
alpha4.writeDigitAscii(3, '0');
alpha4.writeDisplay();
BG.barGraph(0,0);

delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();


  

launch();

}


//launch subroutine



// shuttle graphic animation!

void launch () {

//liftoff message
   for (uint8_t i=0; i<strlen(liftoff)-4; i++) {
    alpha4.writeDigitAscii(0, liftoff[i]);
    alpha4.writeDigitAscii(1, liftoff[i+1]);
    alpha4.writeDigitAscii(2, liftoff[i+2]);
    alpha4.writeDigitAscii(3, liftoff[i+3]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }

alpha4.writeDigitRaw(0, 0b0000000000000000); // 
alpha4.writeDigitRaw(1, 0b0000000110111000); //tail
alpha4.writeDigitRaw(2, 0b0000000011001000); //mid
alpha4.writeDigitRaw(3, 0b0010000001001000); //nose
alpha4.writeDisplay();
delay(500);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitRaw(0, 0b0000100101000000); // exhaust
alpha4.writeDigitRaw(1, 0b0000000110111000); //tail
alpha4.writeDigitRaw(2, 0b0000000011001000); //mid
alpha4.writeDigitRaw(3, 0b0010000001001000); //nose
alpha4.writeDisplay();
delay(500);
  alpha4.clear();
  alpha4.writeDisplay();
  
alpha4.writeDigitRaw(0, 0b0000000000000000);
alpha4.writeDigitRaw(1, 0b0000100101000000);
alpha4.writeDigitRaw(2, 0b0000000110111000);
alpha4.writeDigitRaw(3, 0b0000000011001000);
alpha4.writeDisplay();
delay(500);
  alpha4.clear();
  alpha4.writeDisplay();
alpha4.writeDigitRaw(0, 0b0000000000000000);
alpha4.writeDigitRaw(1, 0b0000000000000000);
alpha4.writeDigitRaw(2, 0b0000100101000000);
alpha4.writeDigitRaw(3, 0b0000000110111000);
alpha4.writeDisplay();
delay(500);
  alpha4.clear();
  alpha4.writeDisplay();

alpha4.writeDigitRaw(0, 0b0000000000000000);
alpha4.writeDigitRaw(1, 0b0000000000000000);
alpha4.writeDigitRaw(2, 0b0000000000000000);
alpha4.writeDigitRaw(3, 0b0000100101000000);
alpha4.writeDisplay();
delay(500);
  alpha4.clear();
  alpha4.writeDisplay();


alpha4.writeDigitRaw(0, 0b0000000000000000);
alpha4.writeDigitRaw(1, 0b0000000000000000);
alpha4.writeDigitRaw(2, 0b0000000000000000);
alpha4.writeDigitRaw(3, 0b0000000000000000);
alpha4.writeDisplay();
delay(1000);
  alpha4.clear();
  alpha4.writeDisplay();

}




//bugs subroutine 

void bugs()  {

//overload message
   for (uint8_t i=0; i<strlen(overload)-4; i++) {
    alpha4.writeDigitAscii(0, overload[i]);
    alpha4.writeDigitAscii(1, overload[i+1]);
    alpha4.writeDigitAscii(2, overload[i+2]);
    alpha4.writeDigitAscii(3, overload[i+3]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }

     int sensorReading = analogRead(BarGraf_POT);
   // map the result to a range from 0 to the number of LEDs:
  const int ledLevel = map(sensorReading, 0, 950, 0, (numbargraphs*30));
  // DANCING SINE BUGS!
  
  // Paint 8 moving bugs onto the bargraph, and watch them dance


  // Create 8 bugs
  float bug[8];
  int x;

  // Zero them all
  for(x=0; x<8; x++)
    bug[x] = 0.0;  
    
  // Do this for 30 seconds
 unsigned long endtime = millis() + 30000; // this needs to be unsigned long not int
  while (millis() < endtime)
  {
    // Clear the canvas
    BG.clear();

    // Move each bug along a sine wave at different rates
    for(x=0; x<8; x++)
    {
      bug[x] += ((PI/8000.0) * (x+1));
      BG.paint((numbargraphs*15)+(sin(bug[x])*(numbargraphs * 15)),HIGH);
    }

    // Send the canvas to the display
    BG.send();
//attempting to interrupt the while loop - works! (mostly- every few times nothing happens. Wait a minute and it works again)

    if (analogRead(BarGraf_POT)<=800) {

break;
  
   }
  

  }
  BG.clear(); BG.send(); delay(500);


}

void regBG()    {
   
     int sensorReading = analogRead(BarGraf_POT);
   // map the result to a range from 0 to the number of LEDs:
  const int ledLevel = map(sensorReading, 0, 950, 0, (numbargraphs*30)); //for some reason 670 is the number that works instead of 1023. Trying to make bugs if power turned up too high.
  // BASIC BARGRAPH!
  BG.barGraph(ledLevel,0);
} 


void arm ()    {

//arm retraction animation

   for (uint8_t i=0; i<5; i++) {
    alpha4.writeDigitRaw(0, arm_0[i]);
    alpha4.writeDigitRaw(1, arm_1[i]);
    alpha4.writeDigitRaw(2, arm_2[i]);
    alpha4.writeDigitRaw(3, arm_3[i]);
    alpha4.writeDisplay();
    delay(200);
alpha4.clear();
alpha4.writeDisplay();
  }

}
void hydrogen () {
//hydrogen animation
for (uint8_t i=0; i<6; i++) {
    alpha4.writeDigitRaw(0, burn_0[i]);
    alpha4.writeDigitRaw(1, burn_1[i]);
    alpha4.writeDigitRaw(2, burn_2[i]);
    alpha4.writeDigitRaw(3, burn_3[i]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}

void autoseq ()   {
//Auto Seq Start animation!
 for (uint8_t i=0; i<13; i++) {
    alpha4.writeDigitRaw(0, auto_0[i]);
    alpha4.writeDigitRaw(1, auto_1[i]);
    alpha4.writeDigitRaw(2, auto_2[i]);
    alpha4.writeDigitRaw(3, auto_3[i]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}

void units () {
//power units animation!
 for (uint8_t i=0; i<20; i++) {
    alpha4.writeDigitRaw(0, digit_0[i]);
    alpha4.writeDigitRaw(1, digit_1[i]);
    alpha4.writeDigitRaw(2, digit_2[i]);
    alpha4.writeDigitRaw(3, digit_3[i]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}


void engine ()  {
//main engine animation!
 for (uint8_t i=0; i<5; i++) {
    alpha4.writeDigitRaw(0, eng_0[i]);
    alpha4.writeDigitRaw(1, eng_1[i]);
    alpha4.writeDigitRaw(2, eng_2[i]);
    alpha4.writeDigitRaw(3, eng_3[i]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();

}
}

void booster()  {
//booster animation!
 for (uint8_t i=0; i<5; i++) {
    alpha4.writeDigitRaw(0, boost_0[i]);
    alpha4.writeDigitRaw(1, boost_1[i]);
    alpha4.writeDigitRaw(2, boost_2[i]);
    alpha4.writeDigitRaw(3, boost_3[i]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
  }
 for (uint8_t i=0; i<5; i++) {
    alpha4.writeDigitRaw(0, boost_0[i]);
    alpha4.writeDigitRaw(1, boost_1[i]);
    alpha4.writeDigitRaw(2, boost_2[i]);
    alpha4.writeDigitRaw(3, boost_3[i]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
  }
   for (uint8_t i=0; i<5; i++) {
    alpha4.writeDigitRaw(0, boost_0[i]);
    alpha4.writeDigitRaw(1, boost_1[i]);
    alpha4.writeDigitRaw(2, boost_2[i]);
    alpha4.writeDigitRaw(3, boost_3[i]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }

}
void callFunc(int randNumber){

if (randNumber==1){
booster();
}
if (randNumber==2){
engine();
}
if (randNumber==3){
units();
}
if (randNumber==4){
autoseq();
}if (randNumber==5){
hydrogen();
}if (randNumber==6){
  arm();
}
}


void phrase1 () {
  // message  1
   for (uint8_t i=0; i<strlen(commander)-4; i++) {
    alpha4.writeDigitAscii(0, commander[i]);
    alpha4.writeDigitAscii(1, commander[i+1]);
    alpha4.writeDigitAscii(2, commander[i+2]);
    alpha4.writeDigitAscii(3, commander[i+3]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}

void phrase2 () {
  // message  1
   for (uint8_t i=0; i<strlen(orders)-4; i++) {
    alpha4.writeDigitAscii(0, orders[i]);
    alpha4.writeDigitAscii(1, orders[i+1]);
    alpha4.writeDigitAscii(2, orders[i+2]);
    alpha4.writeDigitAscii(3, orders[i+3]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}

void phrase3 () {
  // message  1
   for (uint8_t i=0; i<strlen(houston)-4; i++) {
    alpha4.writeDigitAscii(0, houston[i]);
    alpha4.writeDigitAscii(1, houston[i+1]);
    alpha4.writeDigitAscii(2, houston[i+2]);
    alpha4.writeDigitAscii(3, houston[i+3]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}

void phrase4 () {
  // message  1
   for (uint8_t i=0; i<strlen(shuttle)-4; i++) {
    alpha4.writeDigitAscii(0, shuttle[i]);
    alpha4.writeDigitAscii(1, shuttle[i+1]);
    alpha4.writeDigitAscii(2, shuttle[i+2]);
    alpha4.writeDigitAscii(3, shuttle[i+3]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}

void phrase5 () {
  // message  1
   for (uint8_t i=0; i<strlen(nasa)-4; i++) {
    alpha4.writeDigitAscii(0, nasa[i]);
    alpha4.writeDigitAscii(1, nasa[i+1]);
    alpha4.writeDigitAscii(2, nasa[i+2]);
    alpha4.writeDigitAscii(3, nasa[i+3]);
    alpha4.writeDisplay();
    delay(150);
alpha4.clear();
alpha4.writeDisplay();
  }
}
 void enterprise () {

 // ENTERPRISE!
  
  // Put this under your viewport, and stare down the enemy.
  
  unsigned char spot;

  // Do this for 10 seconds

unsigned long endtime = millis() + 10000;
  while (millis() < endtime)
  {
    // Step through all the LEDs from 0 to as many as we have
    for (spot = 0; spot < (numbargraphs*30); spot++)
    {
      BG.clear(); // Clear the canvas

      BG.paint(spot,HIGH); // Turn on one LED

      BG.send(); // Send the canvas to the display
      delay(50); // Pause a moment (decrease delay to increase speed!)
    }
  }
  BG.clear(); BG.send(); delay(500);
  //loop();
 }

void cylon() {
   // By your command.
  
  float angle = 0.0;
  unsigned char center;
  unsigned char y;

  // Do this for 10 seconds
unsigned long endtime = millis() + 10000;
  while (millis() < endtime)
  {
    // Slowly step through an entire sine wave
    for (angle = 0; angle < (PI * 2); angle += 0.0005) 
    {
      // Clear the canvas
      BG.clear();

      // Compute the center LED to light
      center = (sin(angle)* numbargraphs * 13)+(numbargraphs*15);

      // Light up a few on either side of the center
      for (y = center-2; y <= center+2; y++)
        BG.paint(y,HIGH);

      // Send the canvas to the display
      BG.send();
    }
  }
  BG.clear(); BG.send(); delay(500);

//loop();
}

 void music(){
  // FAKE MUSIC!

  // This shows a traditional bargraph, with peak detector
  // We're making a fake waveform here; replace "wave" with your sensor value
  // (scaled from 0 to as many LEDs as you have)
  
  float sine = 0.0, peak = 0.0, wave;

  // Do this for 10 seconds
unsigned long endtime = millis() + 10000;
  while (millis() < endtime)
  {
    // Make a fake music wave by adding up some sine waves
    sine = sine + 0.01;
    wave = (numbargraphs * 15) +
        sin(sine) * (numbargraphs * 5) +
        sin(sine*.7) * (numbargraphs * 5) +
        sin(sine*.3) * (numbargraphs * 5);   

    // Simulate the "peak" value
    if (wave > peak) // If the wave is bigger than the peak, increase the peak        
      peak = wave;
    else // If the wave is smaller than the peak, allow the peak to slowly drop
      peak = peak - 0.001;
      
    // Generate the bargraph
    BG.barGraph(wave,peak);
  }
  BG.clear(); BG.send(); delay(500);
  //loop();
}

void shiftreg() {





  // RANDOM SHIFT REGISTER!

  // We'll use the BG.sendLong() command to shift random bits into a "long" (4-byte) number
  // and send it directly to the bargraph
  
  static unsigned long number2;
  
  // Do this for 10 seconds
  unsigned long endtime = millis() + 10000;
  while (millis() < endtime)
  {
    // shift all the bits in "number2" left by 1
    number2 = (number2 << 1);
    // put a random 0 or 1 into the least-significant bit of "number2"
    number2 |= random(2);
    // send it to the bargraph
    BG.sendLong(number2);
    // short delay
    delay(40);
  }
  BG.clear(); BG.send(); delay(500);
//loop();
}




   








// call one of 9 messages if idle for a minute

void screenSaver(int randNum){

if (randNum==1){
phrase1();
idleLoops = 0;
}
if (randNum==2){
phrase2();
idleLoops = 0;
}
if (randNum==3){
phrase3();
idleLoops = 0;
}
if (randNum==5){ // no reason
phrase5();
idleLoops = 0;
}
if (randNum==4){
phrase4();
idleLoops = 0;
}

if (randNum==6){
enterprise();
idleLoops = 0;
}

if (randNum==7){
cylon();
idleLoops = 0;
}

if (randNum==8){
shiftreg();
idleLoops = 0;
}

if (randNum==9){
music();
idleLoops = 0;
}

}




  
